#include <GL/glut.h>
#include "lbm.h"
#include "particles.h"
void changeSize(int w, int h) 
{
	float ratio = 1.0 * w / h;
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(0, 0, w, h);
	gluOrtho2D(0,1,0,1);
	glMatrixMode(GL_MODELVIEW);
}
void idleFunction(void)
{
	lbm();									// DO LBM STEP
	movepar(0.65);							// MOVE PARTICLES
	glutPostRedisplay();
}
void renderScene(void) 
{
	glClear(GL_COLOR_BUFFER_BIT| GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	drawpar();								// DRAW PARTICLES
	glutSwapBuffers();
}
void init(void)
{
	initlbm();								// INIT LBM
	for(int i=0; i<1e2; i++) lbm();
	initpar();
}
void keys(unsigned char key, int x, int y) 
{
	if (key == 27)		exit(0);
	if (key == ' ') 	initpar();
}
int main(int argc, char**argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH|
	GLUT_DOUBLE| GLUT_RGBA);
	glutInitWindowPosition(100,100);
	glutInitWindowSize(520,520);
	glutCreateWindow("LBM MINI");
	init();									// INIT LBM
	// register callbacks
	glutDisplayFunc(renderScene);
	glutKeyboardFunc(keys);
	glutReshapeFunc(changeSize);
	glutIdleFunc(idleFunction);
	// enter GLUT event processing cycle
	glutMainLoop();
}

